#!/bin/sh
# Single Xwindow/KDE startup script
# (C) Klaus Knopper Jun 2001

PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin:/usr/local/bin:."
export PATH

umask 022

CRE="
[K"
BLUE="[1;34m"
NORMAL="[1;39m"

[ -f /etc/sysconfig/xserver ] && . /etc/sysconfig/xserver
[ -f /etc/sysconfig/knoppix ] && . /etc/sysconfig/knoppix

echo ""
echo -n "${BLUE}Starting X11...${NORMAL}"

ACCEL=""
XOPTIONS=""
NORESET=""
[ -n "$XSERVER" -a -x "/usr/X11R6/bin/$XSERVER" ] && ACCEL="$XSERVER"
[ -L /etc/X11/X ] && ACCEL="$ACCEL /etc/X11/X"

for X in $ACCEL vesa fbdev
do
# Use customized version of XF86Config
XCONFIG="/etc/X11/XF86Config"
BPP="-bpp"
case "$X" in
*XFree86*) XCONFIG="/etc/X11/XF86Config-4"; BPP="-depth"; NORESET="-noreset"; ;;
vesa|fbdev)
	for i in xserver knoppix; do echo 'XSERVER="XFree86"' >> /etc/sysconfig/$i; echo 'XMODULE="'"$X"'"' >> /etc/sysconfig/$i; done
	echo "${NORMAL}"
	echo -n "${BLUE}Retrying with Server ${GREEN}XFree86(${YELLOW}$X${GREEN})${NORMAL} "
	rm -f /etc/X11/XF86Config-4
	mkxf86config >/dev/null 2>&1
	X=XFree86 ; XCONFIG="/etc/X11/XF86Config-4"; BPP="-depth"; NORESET="-noreset"; XOPTIONS=""
	;;
esac
# Try hwsetup-generated flags first, if present
$X $NORESET -xf86config "$XCONFIG" $XOPTIONS  :0 2>/dev/null && break
# Mostly failsafe probe fallbacks
# Some cards prefer 16 bit, especially when low on mem or not SVGA,
# so try this first.
if $X $NORESET -xf86config "$XCONFIG" $BPP 16 :0 2>/dev/null || \
   $X $NORESET -xf86config "$XCONFIG" $BPP 24 :0 2>/dev/null || \
   $X $NORESET -xf86config "$XCONFIG" $BPP 32 :0 2>/dev/null || \
   $X $NORESET -xf86config "$XCONFIG" $BPP  8 :0 2>/dev/null; then break; fi
echo -n "${BLUE}.${NORMAL}"
done &


